<app-loader *ngIf="isLoad">  </app-loader>


<div *ngIf="error && !isLoad">
	<i>{{error}}</i>
</div>

<button mat-flat-button
	(click)="addAchievement()"
	[disabled]="addingData"
	class="mb-20"
	color="primary"> Добавить ИД </button>

<form #achievementForm="ngForm">
	<div class="art-card" *ngIf="achievements">
		<table mat-table  [dataSource]="achievements" >
			<ng-container matColumnDef="name">
				<th mat-header-cell *matHeaderCellDef > Наименование ИД </th>
				<td mat-cell *matCellDef="let row"> {{ row?.name_achievement }}</td>
			</ng-container>

			<ng-container matColumnDef="category">
				<th mat-header-cell *matHeaderCellDef > Категория ИД </th>
				<td mat-cell *matCellDef="let row"> {{ row?.name_category }}
				</td>
			</ng-container>

			<ng-container matColumnDef="maxScore">
				<th mat-header-cell *matHeaderCellDef > Макс. балл </th>
				<td mat-cell *matCellDef="let row"> {{ row?.max_value }}</td>
			</ng-container>


			<ng-container matColumnDef="mark">
				<th mat-header-cell *matHeaderCellDef > Полученный балл </th>
				<td mat-cell *matCellDef="let row"> {{ row?.mark }}</td>
			</ng-container>

			<ng-container matColumnDef="docInfo">
				<th mat-header-cell *matHeaderCellDef > Подтверждающий документ </th>
				<td mat-cell *matCellDef="let row">
					<div *ngIf="row.document"> {{ row.document?.name_type }} </div>
					<div *ngIf="row.file; else notFiles">
						<div *ngFor="let item of row.epgu_documents">
							<button mat-flat-button (click)="openFile($event, item)">
								<mat-icon [svgIcon]="'download'"
									class="mr-8"></mat-icon>
								<span>{{item.path_file}}</span>
							</button>
						</div>
						<div *ngIf="!row.epgu_documents"> <i> файлы не прикреплены </i>  </div>
					</div>
					<ng-template #notFiles> - </ng-template>

				</td>
			</ng-container>

			<ng-container matColumnDef="uid">
				<th mat-header-cell *matHeaderCellDef > UID </th>
				<td mat-cell *matCellDef="let row"> {{ row?.uid }}</td>
			</ng-container>

			<ng-container  matColumnDef="actions">
				<th mat-header-cell *matHeaderCellDef ></th>
				<td mat-cell *matCellDef="let row; let i = dataIndex">
					<button mat-icon-button (click)="delete($event, row.id, i)">
						<mat-icon svgIcon="delete"></mat-icon>
					</button>
				</td>
			</ng-container>


			<ng-container matColumnDef="selectId">
				<td mat-cell *matCellDef="let row" [colSpan]="2">
					<div>
						<mat-form-field fxFlex="">
							<mat-label> Индивидуальное достижение </mat-label>
							<mat-select
								(valueChange)="changeAchievement($event)"
								[(ngModel)]="addingData.achievement"
								name="id_achievement"
								required >
								<mat-option>
									<ngx-mat-select-search
										[(ngModel)]="cls.achievement.search"
										[ngModelOptions]="{standalone: true}"
										[placeholderLabel]="'Поиск'"
										[noEntriesFoundLabel]="'Ничего не найдено'">
										<mat-icon ngxMatSelectSearchClear svgIcon="close"></mat-icon>
									</ngx-mat-select-search>
								</mat-option>

								<mat-option *ngFor="let item of cls.achievement.data | filter: cls.achievement.search" [value]="item">
									{{item.name}}
								</mat-option>


							</mat-select>
						</mat-form-field>
					</div>

				</td>
			</ng-container>

			<ng-container matColumnDef="maxScopeSelect">
				<td mat-cell *matCellDef="let row"> {{addingData.achievement?.max_value}} </td>
			</ng-container>

			<ng-container matColumnDef="setMark">
				<td mat-cell *matCellDef="let row">
					<mat-form-field fxFlex="100">
						<mat-label> Полученный балл </mat-label>
						<input [(ngModel)]="addingData.mark"
							[appMax]="addingData.achievement?.max_value"
							appInteger
							matInput
							name="mark" required>
					</mat-form-field>
				</td>
			</ng-container>


			<ng-container matColumnDef="selectDoc">
				<td mat-cell *matCellDef="let row">
					<button mat-stroked-button (click)="selectDoc()" *ngIf="!addingData.id_document; else docInfoContent"> Выбрать документ </button>
					<ng-template #docInfoContent>
						{{addingData.document.name_type}}
						<button mat-icon-button (click)="addingData.id_document = addingData.document = null"> <mat-icon svgIcon="delete"></mat-icon> </button>
					</ng-template>

					<input required="" [(ngModel)]="addingData.id_document" name="id_document" [hidden]="true">
				</td>
			</ng-container>

			<ng-container matColumnDef="setUid">
				<td mat-cell *matCellDef="let row">
					<mat-form-field fxFlex.lt-md="100">
						<mat-label> UID </mat-label>
						<input matInput [(ngModel)]="addingData.uid" name="uid" appNullValue>
					</mat-form-field>
				</td>
			</ng-container>

			<ng-container matColumnDef="actionsSave">
				<td mat-cell *matCellDef="let row">
					<button mat-icon-button (click)="save()" [disabled]="achievementForm.invalid">
						<mat-icon svgIcon="content-save-outline"></mat-icon>
					</button>
					<button mat-icon-button (click)="deleteForm()">
						<mat-icon svgIcon="cancel" matTooltip="Отменить добавление ИД"></mat-icon>
					</button>
				</td>
			</ng-container>

			<ng-container matColumnDef="noRecord">
				<td mat-footer-cell *matFooterCellDef [colSpan]="headerColumns.length" ><i>Индивидуальных достижений не найдено</i></td>
			</ng-container>


			<tr mat-header-row *matHeaderRowDef="headerColumns"></tr>
			<tr mat-row  *matRowDef="let row; columns: headerColumns; when: !isAddAchievement"> </tr>
			<tr mat-row  *matRowDef="let row; columns: addingColumns; when: isAddAchievement" > </tr>
			<tr mat-footer-row *matFooterRowDef="['noRecord'] "
				[hidden]="achievements.length !== 0"></tr>

		</table>
	</div>
</form>
